//
//  monster.cpp
//  noteDefense
//
//  Created by Mark Kwon on 12/8/15.
//
//

#include "monster.hpp"

using namespace std;

Monster::Monster(vector<Note> notes) : notes(notes){
    positionX = 0;
    selected = false;
    
    move = true;
}

void Monster::draw() {
    
    if (selected) ofSetColor(0, 0, 0);
    else ofSetColor(255, 255, 255);
    
    img.draw(positionX, positionY);

}

void Monster::attack() {
    move = false;
}

bool Monster::update() {
    if (move) {
        positionX += speed;
    }
    return move;
}

void Monster::play() {
    for (int i = 0; i < notes.size(); ++i) {
        notes[i].play();
    }
}

bool Monster::isMonster(float x, float y) {
    return x - positionX >= 0 && x - positionX <= width && y - positionY >= 0 && y - positionY <= height;
}

float Monster::getLocation() {
    return positionX;
}

float Monster::getYLocation() {
    return positionY;
}

float Monster::getWidth() {
    return width;
}

float Monster::getHeight() {
    return height;
}

void Monster::select() {
    selected = true;
}

void Monster::unselect() {
    selected = false;
}

float Monster::damageAmount() {
    return damage;
}

bool Monster::checkAnswer(vector<Note>& guess) {
    if (guess.empty()) return false;
    for (int i = 0; i < guess.size(); ++i) {
        if (guess[i].noteString() != notes[i].noteString()) {
            return false;
        }
    }
    
    return true;
}