//
//  monster.hpp
//  noteDefense
//
//  Created by Mark Kwon on 12/8/15.
//
//

#ifndef monster_hpp
#define monster_hpp

#include <stdio.h>
#include "ofMain.h"
#include "note.hpp"

#include <vector>

class Monster {
public:
    Monster(std::vector<Note> notes);
    void draw();
    bool update();  // return false if monster doesn't move
    
    void play();
    bool isMonster(float x, float y);
    void attack();
    
    void select();
    void unselect();
    
    float damageAmount();
    float getLocation();
    float getYLocation();
    float getWidth();
    float getHeight();
    
    bool checkAnswer(std::vector<Note>& guess);
    
protected:
    ofImage img;
    float positionX, positionY;
    bool selected;
    float speed;
    std::vector<Note> notes;
    
    float width, height;
    
    bool move;
    
    float damage;
};

#endif /* monster_hpp */
