//
//  note.hpp
//  finalProject
//
//  Created by Mark Kwon on 11/11/15.
//
//

#ifndef note_hpp
#define note_hpp

#include <stdio.h>
#include <iostream>
#include <boost/preprocessor.hpp>
#include <vector>

#include "ofMain.h"


#define X_DEFINE_ENUM_WITH_STRING_CONVERSIONS_TOSTRING_CASE(r, data, elem)    \
case elem : return BOOST_PP_STRINGIZE(elem);

#define DEFINE_ENUM_WITH_STRING_CONVERSIONS(name, enumerators)                \
enum name {                                                               \
BOOST_PP_SEQ_ENUM(enumerators)                                        \
};                                                                        \
inline const char* ToString(name v) {                                     \
switch (v) {                                                          \
BOOST_PP_SEQ_FOR_EACH(                                            \
X_DEFINE_ENUM_WITH_STRING_CONVERSIONS_TOSTRING_CASE,          \
name,                                                         \
enumerators                                                   \
)                                                                 \
default: return "[Unknown " BOOST_PP_STRINGIZE(name) "]";         \
}                                                                     \
}

DEFINE_ENUM_WITH_STRING_CONVERSIONS(Notes, (C)(Db)(D)(Eb)(E)(F)(Gb)(G)(Ab)(A)(Bb)(B))

class Note {
public:
    Note(Notes note);
    
    std::string noteString();
    
    void play();
    
private:
    Notes note;
    
    static string getFileName(Notes n);
    
    static const int NUM_NOTES = 12;
    static const float RADIUS = 20;
    static const float NOTE_SPEED = 1;
    
    static bool initialized;
    
    static ofSoundPlayer snds[NUM_NOTES];
    
    // Called only once to create the static vector for the ofSoundPlayer's
    static void makeArray();
    
};

#endif /* note_hpp */
