//
//  nuclearEffect.cpp
//  noteDefense
//
//  Created by Mark Kwon on 12/10/15.
//
//

#include "nuclearEffect.hpp"

NuclearEffect::NuclearEffect() : Effect(500) {
    missile.loadImage("missile.png");
    missile.resize(100, 50);
    missile.mirror(true, false);
    explode = false;
    
    missileY = 0;
    
    explosion.loadSound("explosion.wav");
}

int NuclearEffect::type() {
    return 3;
}

bool NuclearEffect::draw() {
    if (!explode && missileY > 700) {
        explode = true;
        explosion.play();
    }
    
    if (!explode) {
        ofSetColor(255, 255, 255);
        missile.draw(missileX, missileY);
        missileY += 5;
    } else {
        ofNoFill();
        ofSetColor(57, 255, 20, 200);
        ofEllipse(missileX, missileY, radius, radius > 10 ? 10 : radius);
        radius += 30;
    }
    
    if (radius > 1000) numDuration = 0;
    if (explode) return true;
    return false;
}