#pragma once

#include "ofMain.h"
#include "player.hpp"
#include "singleNoteMonster.hpp"
#include "doubleNoteMonster.hpp"
#include "threeNoteMonster.hpp"
#include "fourNoteMonster.hpp"
#include <vector>
#include "attackEffect.hpp"
#include "killEffect.hpp"
#include "nuclearEffect.hpp"

/**
 *  To whoever is reading this code,
 *  sorry I was in a rush
 */


class ofApp : public ofBaseApp{

public:
    void setup();
    void update();
    void draw();

    void keyPressed(int key);
    void keyReleased(int key);
    void mouseMoved(int x, int y );
    void mouseDragged(int x, int y, int button);
    void mousePressed(int x, int y, int button);
    void mouseReleased(int x, int y, int button);
    void windowResized(int w, int h);
    void dragEvent(ofDragInfo dragInfo);
    void gotMessage(ofMessage msg);

private:
    Player p;
    std::vector<Monster*> monsters;
    
    unsigned long int timeAfterGame = 0;
    int tick = 0;
    
    int selected = -1;
    
    void createMonsters();
    void checkDefense();
    
    bool keyDown[255];
    
    int delayTick = 0;
    
    ofSoundPlayer bgm;
    ofSoundPlayer button;
    ofImage background;
    ofImage cursor;
    
    bool playGame;
    bool firstGame;
    bool won;
    
    ofTrueTypeFont font;
    ofTrueTypeFont timeFont;
    
    int minute;
    int second;
    
    int numKills;
    const int KILL_LIMIT = 20;
    
    float mouseX, mouseY;
    
    bool useNuclear = false;
    bool alreadyUsedNuclear = false;
    
    std::vector<Effect*> effects;
    
};
