//
//  player.cpp
//  noteDefense
//
//  Created by Mark Kwon on 12/8/15.
//
//

#include "player.hpp"

Player::Player() {
    img.loadImage("command_center.png");
    img.resize(SIZE, SIZE);
    hp = MAX_HP;
}

void Player::draw() {
    ofSetColor(255,255, 255);
    img.draw(positionX, positionY);
    
    ofSetColor(0, 0, 0);
    ofNoFill();
    ofRect(positionX, positionY - 100, SIZE, 10);
    
    if (hp > 80) ofSetColor(0, 255, 0);
    else if (hp > 40) ofSetColor(255, 255, 0);
    else ofSetColor(255, 0, 0);
    
    ofFill();
    ofRect(positionX, positionY - 100, hp, 10);
}

float Player::playerLocation() {
    return positionX;
}

void Player::damage(float attack) {
    hp -= attack;
}

bool Player::isAlive() {
    return hp > 0;
}

void Player::update() {
}